﻿'Project:       Homework 1
'Programmer:    Anthony DePinto
'Description:   Calculates automobile rental charges based 
'               on the number of miles and the number of days rented.

Option Strict On

Public Class RentalForm

    'Declare module-level constants.
    Const PER_DAY_INTEGER As Integer = 40
    Const PER_MILE_Decimal As Decimal = 0.25D

    Private Sub CalcButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CalcButton.Click
        'Calculate the rental charges
        Dim ChargeDecimal, BeginDecimal, EndDecimal, MilesDecimal As Decimal
        Dim DaysInteger As Integer

        Try
            'Convert the beginning miles if a valid number was input
            BeginDecimal = Decimal.Parse(BeginTextBox.Text)
            Try
                'Convert the ending miles if a valid number was input
                EndDecimal = Decimal.Parse(EndTextBox.Text)
                Try
                    'Convert the number of days if a valid number was input
                    DaysInteger = Integer.Parse(DaysTextBox.Text)

                    'Calculate the number of miles driven and the charges
                    MilesDecimal = EndDecimal - BeginDecimal
                    ChargeDecimal = (MilesDecimal * PER_MILE_Decimal) + (DaysInteger * PER_DAY_INTEGER)

                    'Display the results
                    TotalTextBox.Text = ChargeDecimal.ToString("C")
                    MilesTextBox.Text = MilesDecimal.ToString("N1")

                Catch DaysException As FormatException
                    'Handle the number of days
                    MessageBox.Show("The number of days should be a number (whole number).", "Try Again",
                        MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    With DaysTextBox
                        .Focus()
                        .SelectAll()
                    End With
                End Try
            Catch EndException As FormatException
                'Handle the ending odometer
                MessageBox.Show("The ending odometer must be a number.", "Try Again",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                With EndTextBox
                    .Focus()
                    .SelectAll()
                End With
            End Try
        Catch BeginException As FormatException
            'Handle the number of beginning odometer
            MessageBox.Show("The beginning odometer must be a number.", "Try Again",
                MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            With BeginTextBox
                .Focus()
                .SelectAll()
            End With
        Catch AnException As Exception
            MessageBox.Show("Error: " & AnException.Message)
        End Try
    End Sub

    Private Sub ClearButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearButton.Click
        'Clear the form

        BeginTextBox.Clear()
        EndTextBox.Clear()
        DaysTextBox.Clear()
        TotalTextBox.Clear()
        MilesTextBox.Clear()

    End Sub

    Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click
        'End the program

        Me.Close()
    End Sub


End Class
